#!/usr/bin/perl

my %activehosts;

# open output file to store csv information
open CSVOUT, "> analisi.csv" or die "Error opening analisi.csv for writing";

# open heartbeat for reading and parse its content
# for each host end up with an array of start time followed by end time (couples)
open FILE, $ARGV[0] or die "Error in file open\n";
my $lastnow;
while(<FILE>) {
  my $line = $_;
  my @fields = split(/\s+/, $line);
  my $now = $fields[0];
  my $host = $fields[1];
 
  $lastnow = $now;

  if(not exists $activehosts{$host}) {
    $activehosts{$host}->{"last"} = $now;
    $activehosts{$host}->{"state"} = "off";
    my @timeslot;
    $activehosts{$host}->{"timeslot"} = \@timeslot;
  }
  else {
    my $oldnow = $activehosts{$host}->{"last"};
    if ( $now - $oldnow > 120 ) {
      if( $activehosts{$host}->{"state"} eq "active" ) {
        print "$host off at $oldnow\n";
        push(@{$activehosts{$host}->{"timeslot"}}, $oldnow);
      }
      $activehosts{$host}->{"state"} = "off";
    }
    if ( $now - $oldnow <= 120 ) {
      if( $activehosts{$host}->{"state"} eq "off" ) {
        print "$host on at $oldnow\n";
        push(@{$activehosts{$host}->{"timeslot"}}, $oldnow);
      }
      $activehosts{$host}->{"state"} = "active";
    }
    $activehosts{$host}->{"last"} = $now;
  }
}
close FILE;

my $now = $lastnow;

# this is an awful hack. The last time information can be on or off indicator
# but can be desynchronized with the last time in the beat log file.
# Correct and synchronize with all the time axis for each host.
foreach my $host (keys(%activehosts)) {

  if(not exists $activehosts{$host}) {
    $activehosts{$host}->{"last"} = $now;
    $activehosts{$host}->{"state"} = "off";
    my @timeslot;
    $activehosts{$host}->{"timeslot"} = \@timeslot;
  }
  else {
    my $oldnow = $activehosts{$host}->{"last"};
    if ( $now - $oldnow > 120 ) {
      if( $activehosts{$host}->{"state"} eq "active" ) {
        print "$host off at $oldnow\n";
        push(@{$activehosts{$host}->{"timeslot"}}, $oldnow);
      }
      $activehosts{$host}->{"state"} = "off";
    }
    if ( $now - $oldnow <= 120 ) {
      if( $activehosts{$host}->{"state"} eq "off" ) {
        print "$host on at $oldnow\n";
        push(@{$activehosts{$host}->{"timeslot"}}, $oldnow);
      }
      $activehosts{$host}->{"state"} = "active";
    }
    $activehosts{$host}->{"last"} = $now;
  }
}

my %hosts;

######################################################################
# PHASE 1: read the output produced by ipclass
#494747AC.0001F5C4:10.20.10.52:24.201.29.14:22222:1865:skype;:NoName:skype;:0.158030986786:0.158030986786:46:60:UDP

while(<STDIN>) {
  my $line =$_;
  chomp($line);
  my @fields = split(/:/, $line);
  my $times = hex $fields[0];
  my $ipsrc = $fields[1];
  my $ipdst = $fields[2];
  my $portsrc = $fields[3];
  my $portdst = $fields[4];
  my $l7 = $fields[5];
  my $app = $fields[6];
  my $l7sub = $fields[7];
  my $dur1 = $fields[8];
  my $dur2 = $fields[9];
  my $ser = $fields[10];
  my $cli = $fields[11];
  my $proto = $fields[12];

  if( $proto == "TCP" and ($ser == 0 or $cli == 0)) {
    next;
  }

  if( $ipsrc !~ /10.20.10/ and $ipdst =~ /10.20.10/ ) {
    #next;
    my $tmp = $ipsrc;
    $ipsrc = $ipdst;
    $ipdst = $tmp;
    $tmp = $portsrc;
    $portsrc = $portdst;
    $portdst = $portsrc;
  }

  # add the line ONLY if the logger was switched on (use the heartbeat info)
  my $hosthere;
  if( exists $activehosts{$ipsrc} ) {
    $hosthere = $ipsrc; 
  }
  elsif( exists $activehosts{$ipdst} ) { 
    print "ATTENTION\n";
    $hosthere = $ipdst;
  }
  else {
    print "ATTENTION AGAIN\n";
    next;
  }
  my $cnt = 0;
  for my $ts (@{$activehosts{$hosthere}->{"timeslot"}}) {
    if( $times < $ts ) {
      last;
    }
    $cnt++;
  }
  if( ($cnt % 2) == 1 ) {
  
    if (not exists $hosts{$ipsrc}) {
      $hosts{$ipsrc} = ();
    }
    my $newline = "$times:$ipsrc:$ipdst:$portsrc:$portdst:$l7:$app:$l7sub:$dur1:$dur2:$ser:$cli:$proto";
    push(@{$hosts{$ipsrc}}, $newline);
  }
  #else {
  #  print "Discarding $times\n";
  #}
}

######################################################################
# PHASE 2: sort each host by time
sub estraitempo
  {
    my @fields = split(/:/, $_[0]);
    return $fields[0];
  }

# analyze entry for each host
foreach $host (keys(%hosts)) {

  # sort lines by time
  my @linetimesorted = sort { estraitempo($a) <=> estraitempo($b) } @{$hosts{$host}};

  # re-insert
  ${hosts{$host}} = \@linetimesorted;
}

######################################################################
# PHASE 3: analyze the log produced by each host
my $timeout = 600;
  
# save all filtered session in totsess.log
open( OFILE, ">totsess.log" );

# variables for cumulative statistics

my $UDPcum_totsess = 0;
my $UDPcum_totsess_name = 0;
my $UDPcum_totsess_noname_longer1s = 0;
my $UDPcum_totsess_noname_shorter1s = 0;
my $UDPcum_totsess = 0;
my $UDPcum_totsess_name = 0;
my $UDPcum_totsess_noname_longer1s = 0;
my $UDPcum_totsess_noname_shorter1s = 0;

my $TCPcum_totbytes = 0;
my $TCPcum_totbytes_sess_name = 0;
my $TCPcum_totbytes_sess_noname_longer1s = 0;
my $TCPcum_totbytes_sess_noname_shorter1s = 0;
my $TCPcum_totbytes = 0;
my $TCPcum_totbytes_sess_name = 0;
my $TCPcum_totbytes_sess_noname_longer1s = 0;
my $TCPcum_totbytes_sess_noname_shorter1s = 0;

foreach $host (keys(%hosts)) {

  # modify hostname
  my @fieldsip = split(/\./, $host);
  my $hostname = "host$fieldsip[0].$fieldsip[1].$fieldsip[2].$fieldsip[3]";

  print "analisi $hostname\n";

  # variables for local statistics

  my %totsess = ( "UDP"=>0, "TCP"=>0 );
  my %totsess_name = ( "UDP"=>0, "TCP"=>0 );
  my %totsess_noname_longer1s = ( "UDP"=>0, "TCP"=>0 );
  my %totsess_noname_shorter1s = ( "UDP"=>0, "TCP"=>0 );
  my %totbytes = ( "UDP"=>0, "TCP"=>0 );
  my %totbytes_sess_name = ( "UDP"=>0, "TCP"=>0 );
  my %totbytes_sess_noname_longer1s = ( "UDP"=>0, "TCP"=>0 );
  my %totbytes_sess_noname_shorter1s = ( "UDP"=>0, "TCP"=>0 );

  my %maxbytes_sess_noname_shorter1s = ( "UDP"=>0, "TCP"=>0 );
  my %maxbytes_sess_name = ( "UDP"=>0, "TCP"=>0 );
  my %max_dur_long = ( "UDP"=>0, "TCP"=>0 );

  my $shorter_threshold = 1; # these are those sessions that could hardly captured as shorter than 1s

  # analyze the log
  my @log = @{$hosts{$host}};
  
  # variable to check time sort
  my $conttime = 0;

  foreach $session (@log) {

    # $times:$ipsrc:$ipdst:$portsrc:$portdst:$l7:$app:$l7sub:$dur1:$dur2:$ser:$cli:$proto";

    my @fields = split(/:/, $session);
    my $timestamp = $fields[0];
    my $appname = $fields[6];
    my $dur2 = $fields[9];
    my $ser = $fields[10];
    my $cli = $fields[11];
    my $proto = $fields[12];

    # check time is really sorted
    if( $timestamp < $conttime) {
      print "Errore timestamp\n";
      exit(-1);
    }
    $conttime = $timestamp;

    # write the session on the output file
    print OFILE "$session\n";

    $totsess{$proto} = $totsess{$proto} + 1;
    $totbytes{$proto} = $totbytes{$proto} + $ser + $cli;
      
    if($appname eq "NoName") {
      if($dur2 <= $shorter_threshold) {
        $totsess_noname_shorter1s{$proto} = $totsess_noname_shorter1s{$proto} + 1;
        $totbytes_sess_noname_shorter1s{$proto} = $totbytes_sess_noname_shorter1s{$proto} + $ser + $cli;
        if( ($ser + $cli) > $maxbytes_sess_noname_shorter1s{$proto} ) {
          $maxbytes_sess_noname_shorter1s{$proto}  = $ser + $cli;
        }
      } else {
        if($dur2 > $max_dur_long{$proto}) {
          $max_dur_long{$proto} = $dur2;
        }
        $totsess_noname_longer1s{$proto} = $totsess_noname_longer1s{$proto} + 1;
        $totbytes_sess_noname_longer1s{$proto} = $totbytes_sess_noname_longer1s{$proto} + $ser + $cli;
      }
    } else {
      $totsess_name{$proto} = $totsess_name{$proto} + 1;
      $totbytes_sess_name{$proto} = $totbytes_sess_name{$proto} + $ser + $cli;
      if( ($ser + $cli) > $maxbytes_sess_name{$proto} ) {
        $maxbytes_sess_name{$proto} = $ser + $cli;
      }
    }
  }

  my %meanbytes_noname_shorter1s;
  my %meanbytes_name;
  for my $proto ("TCP", "UDP") {
    if( $totsess_noname_shorter1s{$proto} ne 0 ) {
      $meanbytes_noname_shorter1s{$proto} = sprintf("%0.2f", ($totbytes_sess_noname_shorter1s{$proto} / $totsess_noname_shorter1s{$proto}));
    } else {
      $meanbytes_noname_shorter1s{$proto} = 0;
    }
    if($totsess_name{$proto} ne 0) {
      $meanbytes_name{$proto} = sprintf("%0.2f", ($totbytes_sess_name{$proto} / $totsess_name{$proto}));
    } else {
      $meanbytes_name{$proto} = 0;
    }
  }

  print "STAT------------------------\n";
  print "STAT $hostname\n";
  print CSVOUT "$hostname:";
  for my $proto ("TCP", "UDP") {
    print "STAT for $proto protocol\n";
    print "TOTSESS#[$totsess{$proto}=$totsess_name{$proto}+$totsess_noname_shorter1s{$proto}+$totsess_noname_longer1s{$proto}] ";
    print "TOTBYTE#[$totbytes{$proto}=$totbytes_sess_name{$proto}+$totbytes_sess_noname_shorter1s{$proto}+$totbytes_sess_noname_longer1s{$proto}]\n";
    print "STAT $hostname ";
    print "MEANBYTES_NAME=$meanbytes_name{$proto}:MAXBYTES_SESS_NAME=$maxbytes_sess_name{$proto}\n";
    print "STAT $hostname ";
    print "MEANBYTES_NONAME_SHORTER1S=$meanbytes_noname_shorter1s{$proto}:MAXBYTES_NONAME_SHORTER1S=$maxbytes_sess_noname_shorter1s{$proto}\n";
    print "STAT $hostname ";
    print "MAX_DUR_LONGER1S=$max_dur_long{$proto}\n";

    print CSVOUT "$totsess{$proto}:$totsess_name{$proto}:$totsess_noname_shorter1s{$proto}:$totsess_noname_longer1s{$proto}:";
    print CSVOUT "$totbytes{$proto}:$totbytes_sess_name{$proto}:$totbytes_sess_noname_shorter1s{$proto}:$totbytes_sess_noname_longer1s{$proto}:";
    print CSVOUT "$max_dur_long{$proto}:";

    $cum_totsess{$proto} = $cum_totsess{$proto} + $totsess{$proto};
    $cum_totsess_name{$proto} = $cum_totsess_name{$proto} + $totsess_name{$proto}; 
    $cum_totsess_noname_longer1s{$proto} = $cum_totsess_noname_longer1s{$proto} + $totsess_noname_longer1s{$proto};
    $cum_totsess_noname_shorter1s{$proto} = $cum_totsess_noname_shorter1s{$proto} + $totsess_noname_shorter1s{$proto};

    $cum_totbytes{$proto} = $cum_totbytes{$proto} + $totbytes{$proto};
    $cum_totbytes_sess_name{$proto} = $cum_totbytes_sess_name{$proto} + $totbytes_sess_name{$proto};
    $cum_totbytes_sess_noname_longer1s{$proto} = $cum_totbytes_sess_noname_longer1s{$proto} + $totbytes_sess_noname_longer1s{$proto};
    $cum_totbytes_sess_noname_shorter1s{$proto} = $cum_totbytes_sess_noname_shorter1s{$proto} + $totbytes_sess_noname_shorter1s{$proto};
  }
  print CSVOUT "\n";

}  
print "STAT------------------------\n";
print "STAT cumulative\n";
for my $proto ("TCP", "UDP") {
  print "TOTSESS#[$cum_totsess{$proto}=$cum_totsess_name{$proto}+$cum_totsess_noname_shorter1s{$proto}+$cum_totsess_noname_longer1s{$proto}] ";
  print "TOTBYTE#[$cum_totbytes{$proto}=$cum_totbytes_sess_name{$proto}+$cum_totbytes_sess_noname_shorter1s{$proto}+$cum_totbytes_sess_noname_longer1s{$proto}]\n";

  my $totbytes_2 = $cum_totbytes_sess_name{$proto} + $cum_totbytes_sess_noname_shorter1s{$proto};
  my $ratio_name   = sprintf('%0.2f', $cum_totbytes_sess_name{$proto} * 100 / $totbytes_2);
  my $ratio_noname = sprintf('%0.2f', $cum_totbytes_sess_noname_shorter1s{$proto} * 100 / $totbytes_2);

  print "STAT-- RATIO 100=name + noname=> $ratio_name + $ratio_noname\n";
}

close(OFILE);
